/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.
  
  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
*/
#ifndef	_AP5200_ioctl_H
#define _AP5200_ioctl_H

#define MAX_GRID_COL    12

#define	MODE_MON_QUAD	0
#define	MODE_MON_FULL	1
#define	MODE_MON_ALL	2
#define MODE_MON_CUSTOM	3

#define	MODE_REC_QUAD	4
#define	MODE_REC_FULL	5
#define	MODE_REC_SWITCH	6

typedef struct _AP5200_MODE_PARAMS
{
	unsigned char Mode;
	union
	{
		struct
		{
			unsigned char Channel[4];	/*set 4 channels from left top clockwise*/
		} MON_QUAD;

		struct 
		{
			unsigned char Channel;
		} MON_FULL;	

		struct 
		{
			unsigned char Channel[8];	/*set 8 channels from left top clockwise*/
		} MON_ALL;

		struct
		{
			unsigned char Channel;		/* custom screen, God bless you... */
			unsigned char StartX;
			unsigned char StartY;
			unsigned char Width;
			unsigned char Height;
			unsigned char Ratio;
		} MON_CUSTOM;

		struct
		{
			unsigned char bSlave;
			unsigned char Channel[4];	/*set 4 channels from left top clockwise*/	
		} REC_QUAD;

		struct 
		{
			unsigned char bSlave;
			unsigned char Channel;
		} REC_FULL;

		struct 
		{
			unsigned char bSlave;	
			unsigned char TableSize;
			unsigned char Table[32];
		} REC_SWITCH;	
	};
					
} AP5200_MODE_PARAMS, *PAP5200_MODE_PARAMS;


typedef struct _AP5200_MOTION_PARAMS
{
	unsigned char	Channel;
	unsigned char	bEnable;
	unsigned short	Windows[MAX_GRID_COL];

} AP5200_MOTION_PARAMS, *PAP5200_MOTION_PARAMS;

typedef struct _AP5200_RECT
{
	unsigned short	x;
	unsigned short	y;
	unsigned short	w;
	unsigned short	h;
} AP5200_RECT, *PAP5200_RECT;

typedef struct _AP5200_COLOR
{
	unsigned char	Y;
	unsigned char	Cb;
	unsigned char	Cr;
} AP5200_COLOR, *PAP5200_COLOR;

typedef struct	_AP5200_OSD_PARAMS
{
	unsigned char	bSlave;	//ignored for monitor OSD
	unsigned char 	x;
	unsigned char 	y;
	char*			String;
	unsigned short	StrLen;
	unsigned short	Color;
} AP5200_OSD_PARAMS, *PAP5200_OSD_PARAMS;


typedef struct _AP5200_MOTION_STATUS_CH
{
	unsigned char   on;
	unsigned char   MotionDetected;
	unsigned char   BlindDetected;
	unsigned int    sigma;
	unsigned short  Windows[12];
} AP5200_MOTION_STATUS_CH, *PAP5200_MOTION_STATUS_CH;

typedef struct _AP5200_MOTION_STATUS
{
	AP5200_MOTION_STATUS_CH ch[8];
} AP5200_MOTION_STATUS, *PAP5200_MOTION_STATUS;

typedef struct _AP5200_MOTION_ENABLE_CH
{
	unsigned char   ch;
	unsigned char   enable;
	unsigned char   show;
	unsigned char   accumulate;
	unsigned char   TH_L;
	unsigned char   TH_H;
	unsigned short  TH_motion;
	unsigned short  TH_blind;
	unsigned char   TH_win;
	unsigned char   REF_catch;
	unsigned char   sel_TH_motion;
	unsigned short  Windows[12];
} AP5200_MOTION_ENABLE_CH, *PAP5200_MOTION_ENABLE_CH;


typedef struct _AP5200_PLAYBACK {
	unsigned char dest_ch;
	unsigned char enable;
	unsigned char isNtsc;
} AP5200_PLAYBACK, *PAP5200_PLAYBACK;

#endif
