/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.
  
  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
*/
#ifndef	_I2C_H
#define	_I2C_H
#include "driver.h"

// GPIO offset in CPLD
#define GPIO_OUT	0x24
#define GPIO_IN		0x28


// PCA9456 REGISTERS OFFSET IN CPLD
#define I2CSTA	0x00
#define I2CTO	0x00
#define I2CDAT	0x04
#define I2CADR	0x08
#define I2CCON	0x0C
// PCA9456 I2CCON BITS
#define AA				0x80
#define ENSIO			0x40
#define STA				0x20
#define STO				0x10
#define SI				0x08
#define CLK_330_KHZ  0x00
#define CLK_288_KHZ  0x01
#define CLK_217_KHZ  0x02
#define CLK_146_KHZ  0x03
#define CLK_88_KHZ  	0x04
#define CLK_59_KHZ  	0x05
#define CLK_44_KHZ  	0x06
#define CLK_36_KHZ  	0x07
// PCA9456 I2CSTA	VALUES
#define	STA_TX		0x08	//Start txmitted
#define	REP_STA		0x10	//Repeated start txmitted
#define	I2C_WR_ACK	0x18	//Acknowledge on I2C write address
#define	DATA_TX_ACK 0x28	//Acknowledge on data txmitted
#define	I2C_RD_ACK 	0x40	//Acknowledge on I2C read address
#define	DATA_RX_ACK 0x50	//Acknowledge on data rxved
#define	NOP			0xF8

//I2C Devices Addresses
#define I2CID_MUX			0xE0
#define I2CID_SAA7121H		0x88

//Miscellaneous
#define	I2C_READ		0x01
#define	I2C_TIMEOUT		0xFF
#define	I2C_CMD_MASK	(ENSIO | CLK_330_KHZ)

#define	SAA7113H_BRIGHT		0x0A
#define	SAA7113H_CONTRAST	0x0B
#define	SAA7113H_HUE		0x0D




unsigned char PCA9564_Init(PETHJPG2K pDevice);
unsigned char SAA7113H_Init(PETHJPG2K pDevice, unsigned char Decoder , unsigned char bNtsc);
unsigned char SAA7121H_Init(PETHJPG2K pDevice, unsigned char bNtsc);
unsigned char SAA7113H_SetBrightness(PETHJPG2K pDevice, unsigned char Decoder ,unsigned char Data );
unsigned char SAA7113H_SetContrast(PETHJPG2K pDevice, unsigned char Decoder ,unsigned char Data );
unsigned char SAA7113H_SetHue(PETHJPG2K pDevice, unsigned char Decoder ,unsigned char Data );
unsigned char SAA7113H_WriteByte(PETHJPG2K pDevice, unsigned char Decoder, unsigned char SubAddress, unsigned char Data);
unsigned char SAA7113H_ReadByte(PETHJPG2K pDevice, unsigned char Decoder, unsigned char SubAddress, unsigned char* pData);
unsigned char SAA7121H_WriteByte(PETHJPG2K pDevice, unsigned char Decoder, unsigned char SubAddress, unsigned char Data);
unsigned char SAA7121H_ReadByte(unsigned char Decoder, unsigned char SubAddress, unsigned char* pData);


#endif	/* _I2C_H */
