/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.
  
  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
******************************************************************************/
#ifndef ETHJPG2K_H
#define ETHJPG2K_H
#include "plat.h"

#define ETHJPG2K_ERROR(x) 		     				((0x01L<<29)|(x))
#define ETHJPG2K_ERROR_DEVICE_RUNNING				ETHJPG2K_ERROR(0)
#define	ETHJPG2K_ERROR_WRONG_FW_ID					ETHJPG2K_ERROR(1)
#define	ETHJPG2K_ERROR_CREATE_OBJ					ETHJPG2K_ERROR(2)
#define	ETHJPG2K_ERROR_BUFFER_TOO_SMALL				ETHJPG2K_ERROR(2)
#define	ETHJPG2K_ERROR_NO_DATA_AVAILABLE			ETHJPG2K_ERROR(2)





// IOCTL
// moved to plat.h: #define IOCTL_ETHJPG2K(x)		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800+x, METHOD_BUFFERED, FILE_ANY_ACCESS)			

#define IOCTL_ETHJPG2K_VIDEO_SET_MODE       	IOCTL_ETHJPG2K(0x00)
#define IOCTL_ETHJPG2K_VIDEO_SET_BRIGHTNESS		IOCTL_ETHJPG2K(0x01)
#define IOCTL_ETHJPG2K_VIDEO_SET_CONTRAST   	IOCTL_ETHJPG2K(0x02)
#define	IOCTL_ETHJPG2K_VIDEO_SET_HUE			IOCTL_ETHJPG2K(0x03)

#define	IOCLT_ETHJPG2K_VIDEO_CLEAR				IOCTL_ETHJPG2K(0x04)

#define	IOCLT_ETHJPG2K_VIDEO_PLAYBACK				IOCTL_ETHJPG2K(0x05)

#define IOCTL_ETHJPG2K_MOTION_ENABLE			IOCTL_ETHJPG2K(0x10)
#define IOCTL_ETHJPG2K_MOTION_DISABLE			IOCTL_ETHJPG2K(0x11)
#define IOCTL_ETHJPG2K_MOTION_GET_STATUS  		IOCTL_ETHJPG2K(0x12)	
#define IOCTL_ETHJPG2K_MOTION_GET_STATUS_FAST  		IOCTL_ETHJPG2K(0x13)	

#define IOCTL_ETHJPG2K_MONITOR_ENABLE_OSD     	IOCTL_ETHJPG2K(0x20)
#define IOCTL_ETHJPG2K_MONITOR_DISABLE_OSD     	IOCTL_ETHJPG2K(0x21)
#define IOCTL_ETHJPG2K_MONITOR_CLEAR_OSD	  	IOCTL_ETHJPG2K(0x22)
#define IOCTL_ETHJPG2K_MONITOR_WRITE_OSD	 	IOCTL_ETHJPG2K(0x23)

#define IOCTL_ETHJPG2K_RECORD_MST_ENABLE_OSD	IOCTL_ETHJPG2K(0x30)
#define IOCTL_ETHJPG2K_RECORD_MST_DISABLE_OSD	IOCTL_ETHJPG2K(0x31)
#define IOCTL_ETHJPG2K_RECORD_MST_CLEAR_OSD		IOCTL_ETHJPG2K(0x32)
#define IOCTL_ETHJPG2K_RECORD_MST_WRITE_OSD		IOCTL_ETHJPG2K(0x33)

#define IOCTL_ETHJPG2K_RECORD_SLV_ENABLE_OSD	IOCTL_ETHJPG2K(0x40)
#define IOCTL_ETHJPG2K_RECORD_SLV_DISABLE_OSD	IOCTL_ETHJPG2K(0x41)
#define IOCTL_ETHJPG2K_RECORD_SLV_CLEAR_OSD		IOCTL_ETHJPG2K(0x42)
#define IOCTL_ETHJPG2K_RECORD_SLV_WRITE_OSD		IOCTL_ETHJPG2K(0x43)

#define	IOCTL_ETHJPG2K_ENCDEC_RESET				IOCTL_ETHJPG2K(0x50)
#define	IOCTL_ETHJPG2K_ENCDEC_LOAD_FIRMWARE		IOCTL_ETHJPG2K(0x51)
#define	IOCTL_ETHJPG2K_ENCDEC_START				IOCTL_ETHJPG2K(0x52)
#define	IOCTL_ETHJPG2K_ENCDEC_STOP				IOCTL_ETHJPG2K(0x53)
#define	IOCTL_ETHJPG2K_ENCDEC_READ				IOCTL_ETHJPG2K(0x54)
#define	IOCTL_ETHJPG2K_ENCDEC_WRITE				IOCTL_ETHJPG2K(0x55)

#define IOCTL_ETHJPG2K_GPIO_READ				IOCTL_ETHJPG2K(0x60)
#define IOCTL_ETHJPG2K_GPIO_WRITE				IOCTL_ETHJPG2K(0x61)
#define IOCTL_ETHJPG2K_SET_SLAVE_PATH			IOCTL_ETHJPG2K(0x62)

/* linux specific ioctls */

#define IOCTL_ETHJPG2K_LINUX_INIT                                 IOCTL_ETHJPG2K(0x70)
#define IOCTL_ETHJPG2K_LINUX_GETBSIZE                             IOCTL_ETHJPG2K(0x71)
#define IOCTL_ETHJPG2K_LINUX_WAITDATA                             IOCTL_ETHJPG2K(0x72)

/*Typedef's & struct's*/


/* for IOCTL_ETHJPG2K_LINUX_WAITDATA */
struct ethjpg2k_linux_waitdata {
	unsigned long head;
	int overflow;
};

/* for the image header passed to the user level program */
struct ethjpg2k_linux_hdr {
  unsigned long field;
  unsigned long index;
  union
  {
    unsigned long info;
    struct {
      unsigned char version;
      unsigned char reserved;
      unsigned char videoFormat;
      unsigned char codeFormat;
    } Info_s;
  } Info_u;
  unsigned long size;

  unsigned long start;
  unsigned int overflow;

  unsigned int ticket;
};

/* for the image passed from user level */
struct ethjpg2k_linux_decode {
  unsigned long start;
  unsigned long size;
};

typedef struct _ETHJPG2K_VIDEO_ENCODE_FIRMWARE_PARAMS
{
	unsigned char 	VFORMAT;			//Video Standard;
	unsigned char 	PREC;				//Precision;
	unsigned char 	XFORMLEV;			//Wavelet Transform Levels;
	unsigned char 	UNI;				//Component Polarity;
	
	unsigned char 	CBSIZE;				//Codeblock Dimensions;
	unsigned char 	WKERNEL_QUANT;		//Wavelet Kernel;
	unsigned char 	STALLPAR;			//SkipFields;
	unsigned char 	ATTRTYPE;			//Attribute Output Format;
	
	unsigned char 	RCTYPE;			//Rate Control;
	unsigned char 	RCVAL[3];				//Target Size Or Quality;
	
	unsigned char 	J2KPROG;			//J2K Progression;
	unsigned char 	PICFG;				//Pixel If Config;
	unsigned char 	QFACT;				//Quantize Factor;
	unsigned char 	COD_STYLE;			//Code Output Format;
	
	unsigned short	STEPSIZES[19];		//Quantize Stepsizes;
	unsigned char 	LOAD_SS;        	
	unsigned char	LOAD_VW;			//Visual Weight Options;
	
	unsigned short 	VW_Y;				//Y_Visual Weight Factor;
	unsigned short 	VW_CB;				//Cb_VisualWeightFactor[19];
	unsigned short 	VW_CR;				//Cr_VisualWeightFactor[19];
	unsigned char	RESERVED[6];	
	unsigned long 	LayersTargets[16];	//Target Size or Target Quality
} ETHJPG2K_VIDEO_ENCODE_FIRMWARE_PARAMS, *PETHJPG2K__VIDEO_ENCODE_FIRMWARE_PARAMS;

typedef struct _ETHJPG2K__VIDEO_DECODE_FIRMWARE_PARAMS
{
	unsigned char 	VFORMAT;		//Video Standard;
	unsigned char 	PREC;			//Precision;
	unsigned char	RESERVED_0;
	unsigned char 	UNI;			//Component Polarity;
	unsigned char	RESERVED_1[5];
	unsigned char 	PICFG;			//Pixel If Config;
	unsigned char 	DRES;			//Decode Resolution Settings;
	unsigned char 	COD_STYLE;		//Code Input Format;
} ETHJPG2K_VIDEO_DECODE_FIRMWARE_PARAMS, PETHJPG2K_VIDEO_DECODE_FIRMWARE_PARAMS;


typedef struct _ETHJPG2K_HIPI_FIRMWARE_PARAMS
{
	unsigned short	XTOT;	// number oy bytes per line
	unsigned short 	YTOT;   // number of lines per frame
	unsigned char 	PMODE;  // pixel format
	union {
		ETHJPG2K_VIDEO_ENCODE_FIRMWARE_PARAMS	EncodeParams;
		ETHJPG2K_VIDEO_DECODE_FIRMWARE_PARAMS	DecodeParams;
	} sub;
} ETHJPG2K_HIPI_FIRMWARE_PARAMS, *PETHJPG2K_HIPI_FIRMWARE_PARAMS;


typedef union _ETHJPG2K_FIRMWARE_PARAMS
{
	ETHJPG2K_VIDEO_ENCODE_FIRMWARE_PARAMS	EncodeParams;
	ETHJPG2K_VIDEO_DECODE_FIRMWARE_PARAMS	DecodeParams;
	ETHJPG2K_HIPI_FIRMWARE_PARAMS		HipiParams;

} ETHJPG2K_FIRMWARE_PARAMS, *PETHJPG2K_FIRMWARE_PARAMS;

typedef struct _ETHJPG2K_FIRMWARE_DATA
{
	unsigned char 	bSlave;
	unsigned char	Type;
	unsigned short 	FirmwareId;	
	unsigned long*	pFirmware;
	unsigned long 	FirmwareSizeInDwords;
	PETHJPG2K_FIRMWARE_PARAMS	pFirmwareParameters;

} ETHJPG2K_FIRMWARE_DATA, *PETHJPG2K_FIRMWARE_DATA;



//typedef struct 


#endif  //ETHJPG2K_H
