/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.
  
  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
******************************************************************************/

//every char bitmap is 6 bits wide for 8 bits height
typedef unsigned char FONT[8];


#define EOL		0xfe	//end of line

#define S00 		0x80
#define S01 		0x81
#define S02     	0x82
#define S03     	0x83
#define S04		0x84
#define S05		0x85
#define S06		0x86
#define S07		0x87
#define S08		0x88
#define S09		0x89

#define AAA		0x8a
#define BBB		0x8b
#define CCC		0x8c
#define DDD		0x8d
#define EEE		0x8e
#define FFF		0x8f
#define GGG		0x90
#define HHH		0x91
#define III		0x92
#define JJJ		0x93
#define KKK		0x94
#define LLL		0x95
#define MMM		0x96
#define NNN		0x97
#define OOO		0x98
#define PPP		0x99
#define QQQ		0x9a
#define RRR		0x9b
#define SSS		0x9c
#define TTT		0x9d
#define UUU		0x9e
#define VVV		0x9f
#define WWW		0xa0
#define XXX		0xa1
#define YYY		0xa2
#define ZZZ		0xa3

#define aaa		0xa4
#define bbb		0xa5
#define ccc		0xa6
#define ddd		0xa7
#define eee		0xa8
#define fff		0xa9
#define ggg		0xaa
#define hhh		0xab
#define iii		0xac
#define jjj		0xad
#define kkk		0xae
#define lll		0xaf
#define mmm		0xb0
#define nnn		0xb1
#define ooo		0xb2
#define ppp		0xb3
#define qqq		0xb4
#define rrr		0xb5
#define sss		0xb6
#define ttt		0xb7
#define uuu		0xb8
#define vvv		0xb9
#define www		0xba
#define xxx		0xbb
#define yyy		0xbc
#define zzz		0xbd

#define COL		0xbe
#define DOT		0xbf

#define BLK		0x7f

unsigned char tFONT_TABLE[] =
{
	//---0---
 	0x1e,
 	0x21,
 	0x23,
 	0x25,
 	0x29,
 	0x31,
 	0x21,
 	0x1e,

	//---1---
 	0x04,
 	0x0c,
 	0x04,
 	0x04,
 	0x04,
 	0x04,
 	0x04,
 	0x0e,

	//---2---
 	0x1e,
 	0x31,
 	0x01,
 	0x02,
 	0x04,
 	0x08,
 	0x10,
 	0x3f,

	//---3---
 	0x1e,
 	0x31,
 	0x01,
 	0x0e,
 	0x01,
 	0x01,
 	0x31,
 	0x1e,

	//---4---
 	0x02,
 	0x06,
 	0x0a,
 	0x12,
 	0x22,
 	0x3f,
 	0x02,
 	0x02,

	//---5---
 	0x3f,
 	0x20,
 	0x20,
 	0x3e,
 	0x01,
 	0x01,
 	0x31,
 	0x1e,

	//---6---
 	0x1e,
 	0x23,
 	0x20,
 	0x3e,
 	0x21,
 	0x21,
 	0x21,
 	0x1e,

	//---7---
 	0x3f,
 	0x21,
 	0x01,
 	0x02,
 	0x04,
 	0x04,
 	0x04,
 	0x04,

	//---8---
 	0x1e,
 	0x21,
 	0x21,
 	0x1e,
 	0x21,
 	0x21,
 	0x21,
 	0x1e,

	//---9---
 	0x1e,
 	0x21,
 	0x21,
 	0x21,
 	0x1f,
 	0x01,
 	0x31,
 	0x1e,

	//---A---
 	0x1e,
 	0x21,
 	0x21,
 	0x21,
 	0x3f,
 	0x21,
 	0x21,
 	0x00,

	//---B---
 	0x3e,
 	0x21,
 	0x21,
 	0x3e,
 	0x21,
 	0x21,
 	0x3e,
 	0x00,

	//---C---
 	0x1e,
 	0x21,
 	0x20,
 	0x20,
 	0x20,
 	0x21,
 	0x1e,
 	0x00,

	//---D---
 	0x3e,
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x3e,
 	0x00,

	//---E---
 	0x3f,
 	0x20,
 	0x20,
 	0x3e,
 	0x20,
 	0x20,
 	0x3f,
 	0x00,

	//---F---
	0x3f,
	0x20,
	0x20,
	0x3e,
	0x20,
	0x20,
	0x20,
	0x00,

	//---G---
 	0x1e,
 	0x21,
 	0x20,
 	0x27,
 	0x21,
 	0x21,
 	0x1e,
 	0x00,

	//---H---
 	0x21,
 	0x21,
 	0x21,
 	0x3f,
 	0x21,
 	0x21,
 	0x21,
 	0x00,

	//---I---
 	0x1c,
 	0x08,
 	0x08,
 	0x08,
 	0x08,
 	0x08,
 	0x1c,
 	0x00,

	//---J---
 	0x02,
 	0x02,
 	0x02,
 	0x02,
 	0x02,
 	0x12,
 	0x0c,
 	0x00,

	//---K---
 	0x21,
 	0x22,
 	0x24,
 	0x28,
 	0x34,
 	0x22,
 	0x21,
 	0x00,

	//---L---
 	0x20,
 	0x20,
 	0x20,
 	0x20,
 	0x20,
 	0x20,
 	0x3f,
 	0x00,

	//---M---
 	0x21,
 	0x33,
 	0x2d,
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x00,

	//---N---
 	0x21,
 	0x31,
 	0x39,
 	0x2d,
 	0x27,
 	0x23,
 	0x21,
 	0x00,

	//---O---
 	0x1e,
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x1e,
 	0x00,

	//---P---
 	0x3e,
 	0x21,
 	0x21,
 	0x3e,
 	0x20,
 	0x20,
 	0x20,
 	0x00,

	//---Q---
 	0x1e,
 	0x21,
 	0x21,
 	0x21,
 	0x25,
 	0x23,
 	0x1e,
 	0x00,

	//---R---
 	0x3e,
 	0x21,
 	0x21,
 	0x3e,
 	0x24,
 	0x22,
 	0x21,
 	0x00,

	//---S---
 	0x1e,
 	0x21,
 	0x20,
 	0x1e,
 	0x01,
 	0x21,
 	0x1e,
 	0x00,

	//---T---
 	0x1f,
 	0x04,
 	0x04,
 	0x04,
 	0x04,
 	0x04,
 	0x04,
 	0x00,

	//---U---
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x21,
 	0x1e,
 	0x00,

	//---V---
	0x21,
	0x21,
	0x21,
	0x21,
	0x21,
	0x12,
	0x0c,
	0x00,

	//---W---
	0x22,
	0x22,
	0x22,
	0x2a,
	0x2a,
	0x2a,
	0x14,
	0x00,

	//---X---
	0x21,
	0x21,
	0x12,
	0x0c,
	0x12,
	0x21,
	0x21,
	0x00,

	//---Y---
	0x22,
	0x22,
	0x14,
	0x08,
	0x08,
	0x08,
	0x08,
	0x00,

	//---Z---
	0x3f,
	0x01,
	0x02,
	0x04,
	0x08,
	0x10,
	0x3f,
	0x00,

	//--------a---------
 	0x00,
 	0x00,
 	0x1c,
 	0x02,
 	0x1e,
 	0x22,
 	0x1d,
 	0x00,
        
	//--------b---------
 	0x20,
 	0x20,
 	0x3c,
 	0x22,
 	0x22,
 	0x22,
 	0x3c,
 	0x00,
        
	//--------c---------
 	0x00,
 	0x00,
 	0x1c,
 	0x22,
 	0x20,
 	0x22,
 	0x1c,
 	0x00,
        
	//--------d---------
 	0x02,
 	0x02,
 	0x1e,
 	0x22,
 	0x22,
 	0x22,
 	0x1e,
 	0x00,
        
	//--------e---------
 	0x00,
 	0x00,
 	0x1c,
 	0x22,
 	0x3e,
 	0x20,
 	0x1e,
 	0x00,
        
	//--------f---------
	0x0e,
	0x08,
	0x08,
	0x3e,
	0x08,
	0x08,
	0x08,
	0x00,
        
	//--------g---------
 	0x00,
 	0x00,
 	0x1c,
 	0x22,
 	0x22,
 	0x1e,
 	0x02,
 	0x3c,
        
	//--------h---------
 	0x20,
 	0x20,
 	0x3c,
 	0x22,
 	0x22,
 	0x22,
 	0x22,
 	0x00,
        
	//--------i---------
 	0x08,
 	0x00,
 	0x08,
 	0x08,
 	0x08,
 	0x08,
 	0x08,
 	0x00,
        
	//--------j---------
 	0x02,
 	0x00,
 	0x02,
 	0x02,
 	0x02,
 	0x02,
 	0x12,
 	0x0c,
        
	//--------k---------
 	0x20,
 	0x20,
 	0x22,
 	0x24,
 	0x28,
 	0x34,
 	0x22,
 	0x00,
        
	//--------l---------
 	0x18,
 	0x08,
 	0x08,
 	0x08,
 	0x08,
 	0x08,
 	0x1c,
 	0x00,
        
	//--------m---------
 	0x00,
 	0x00,
 	0x14,
 	0x2a,
 	0x2a,
 	0x22,
 	0x22,
 	0x00,
        
	//--------n---------
 	0x00,
 	0x00,
 	0x2c,
 	0x32,
 	0x22,
 	0x22,
 	0x22,
 	0x00,
        
	//--------o---------
 	0x00,
 	0x00,
 	0x1c,
 	0x22,
 	0x22,
 	0x22,
 	0x1c,
 	0x00,
        
	//--------p---------
 	0x00,
 	0x00,
 	0x3c,
 	0x22,
 	0x22,
 	0x3c,
 	0x20,
 	0x20,
        
	//--------q---------
 	0x00,
 	0x00,
 	0x1e,
 	0x22,
 	0x22,
 	0x1e,
 	0x02,
 	0x02,
        
	//--------r---------
 	0x00,
 	0x00,
 	0x2c,
 	0x32,
 	0x20,
 	0x20,
 	0x20,
 	0x00,
        
	//--------s---------
 	0x00,
 	0x00,
 	0x1e,
 	0x20,
 	0x1c,
 	0x02,
 	0x3c,
 	0x00,
        
	//--------t---------
 	0x08,
 	0x08,
 	0x3e,
 	0x08,
 	0x08,
 	0x08,
 	0x0e,
 	0x00,
        
	//--------u---------
 	0x00,
 	0x00,
 	0x22,
 	0x22,
 	0x22,
 	0x22,
 	0x1c,
 	0x00,
         
	//--------v---------
	0x00,
	0x00,
	0x22,
	0x22,
	0x22,
	0x14,
	0x08,
	0x00,
        
	//--------w---------
	0x00,
	0x00,
	0x22,
	0x22,
	0x2a,
	0x2a,
	0x14,
	0x00,
        
	//--------x---------
	0x00,
	0x00,
	0x22,
	0x14,
	0x08,
	0x14,
	0x22,
	0x00,
        
	//--------y---------
	0x00,
	0x00,
	0x22,
	0x22,
	0x1e,
	0x02,
	0x22,
	0x1c,
        
	//--------z---------
	0x00,
	0x00,
	0x3e,
	0x04,
	0x08,
	0x10,
	0x3e,
	0x00,

	//---:---
	0x00,
	0x0c,
	0x0c,
	0x00,	
	0x00,
	0x0c,
	0x0c,
	0x00,

	//---.---
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x0c,
	0x0c,
	0x00,
};

