/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.
  
  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
*/
#ifndef _DRIVER_H_ 
#define _DRIVER_H_ 1

#include "plx9056.h"
#include <asm/io.h>
#include <linux/delay.h>

struct ETHJPG2K_s {
	/* compatibility with windows ce code */
	unsigned long PLX9056_BAR2[2];
	struct plx_dev *plx[2];
	int DeviceIsRunning[2];
	int DeviceIsBooting[2];
	int FirmwareType[2];
	u16  AP5200_Shadow[0x100];
	int Bridges;

	struct
	{
		/*Current video standard 1=NTSC, 0=PAL*/
                unsigned        bNtsc                           :1;
        }Flags;

	spinlock_t csMotionStatus;
};

typedef struct ETHJPG2K_s * PETHJPG2K;

extern PETHJPG2K pethjpg2k;

int driver_get_n(struct plx_dev *plx);

#define RD(address) \
ioread32((void *) (address))
#define WD(address, data) \
iowrite32(data, (void *) (address))

#define Sleep(x) mdelay(x)

#define UCHAR u8

#define EnterCriticalSection(x) spin_lock(x)

#define LeaveCriticalSection(x) spin_unlock(x)

#if 1
#define DEBUGP(fmt, args...) printk(fmt, ## args)
#else
#define DEBUGP(fmt, args...) while(0)
#endif

extern inline void wait_sync(void) {
  set_current_state(TASK_INTERRUPTIBLE);
  schedule_timeout(HZ/50);
}


#endif
