/*
  Copyright 2007 Eurotech S.P.A. (Luca Calligaris)
  Copyright 2007 Christian Pellegrin <chripell@gmail.com> EVOL S.R.L.
  
  This software is released under the GPL v2. Please see the file
  COPYING in the top-level directory.
*/

#ifndef _LIBE0904_H_ 
#define _LIBE0904_H_  1

#include "ethjpg2k.h"
#include "AP5200_ioctl.h"
#include "adv202_hdr.h"

struct e0904_ch {
  int fd[2];

  unsigned char * b;
  unsigned long bsize;
  int last_isNtsc;
  int cod_style;
  int video_norm;
};

typedef int (*e0904_frame_cb) (struct ethjpg2k_linux_hdr *hdr, unsigned char * data, unsigned long len);

typedef void (*e0904_frame_in_cb) (unsigned char * data, unsigned long len);

typedef int (*e0904_len_cb) (void);

struct e0904_ch* simple_e0904_encoder(char *dev);

int simple_e0904_board_init(struct e0904_ch *e, int isNtsc, char *b, 
			    ETHJPG2K_FIRMWARE_DATA *fwdata,
			    ETHJPG2K_FIRMWARE_PARAMS *fwparams,
			    int slave_path);

void simple_e0904_board_noinit(struct e0904_ch *e, int isNtsc);

int simple_e0904_encoder_run(struct e0904_ch* e, e0904_frame_cb cb);

int simple_e0904_decoder_run(struct e0904_ch* e, e0904_len_cb cbl, e0904_frame_in_cb cbf, int ad_hdr);

int simple_e0904_ioctl(struct e0904_ch* e, int code, void *arg);

void simple_e0904_free(struct e0904_ch* e);

void simple_e0904_force_stop(struct e0904_ch* e);

int simple_e0904_hipi(struct e0904_ch *enc, struct e0904_ch *dec,
		      char *fw, ETHJPG2K_FIRMWARE_DATA *fwdata, ETHJPG2K_FIRMWARE_PARAMS *fwparams,
		      int n, 
		      char **in, int *ins,
		      char **out, int *outs);

#endif
